import { _ as _applyDecoratedDescriptor } from '../../applyDecoratedDescriptor-e87190e7.js';
import { setComponentTemplate } from '@ember/component';
import { hbs } from 'ember-cli-htmlbars';
import { action } from '@ember/object';
import { scheduleOnce } from '@ember/runloop';
import Component from '@glimmer/component';

var TEMPLATE = hbs("<LinkTo\n    @route={{@route}}\n    @models={{if @model (array @model) this.models}}\n    @activeClass={{this.activeClass}}\n    @query={{if @query @query (hash)}}\n    @replace={{@replace}}\n    @current-when={{@currentWhen}}\n    class=\"dropdown-link dropdown-item\"\n    {{on \"click\" this.onClick}}\n    ...attributes\n>\n    {{yield}}\n</LinkTo>");

var _class;
let DropdownLinkComponent = (_class = class DropdownLinkComponent extends Component {
  /**
   * ember's <LinkTo> complains if you pass it a @models arg value that is not an array
   * but we dont want to require passing in that arg if the route needs no models so
   * just default it to an empty array
   */
  get models() {
    return this.args.models ?? [];
  }
  /**
   * The CSS class that is applied when the LinkTo's route is considered active
   * or the `currentWhen` arg evaluates to true. Can be removed entirely by
   * passing in an empty string
   */


  get activeClass() {
    return this.args.activeClass ?? 'active';
  }
  /**
   * Handles anchor tag onclick events
   * @memberof DropdownLinkComponent
   */


  onClick() {
    scheduleOnce('afterRender', this.args.dd.actions, 'close');
  }

}, (_applyDecoratedDescriptor(_class.prototype, "onClick", [action], Object.getOwnPropertyDescriptor(_class.prototype, "onClick"), _class.prototype)), _class);
setComponentTemplate(TEMPLATE, DropdownLinkComponent);

export { DropdownLinkComponent as default };
